<?php
/*
 * Plugin COG
 * (c] 2009 Guillaume Wauquier
 * Distribue sous licence GPL
 *
 */
function cog_config_tab_fichier($objet = null)
{
    $tab_cog_fichier = [
        'cog_commune' => ['nom' => 'Communes',
            'cle_unique' => ['departement', 'code'],
            'fichier' => 'https://www.insee.fr/fr/statistiques/fichier/3363419/comsimp2018-txt.zip',
            'nom_fichier' => 'comsimp2018.txt',
        ],
        'cog_canton' => ['nom' => 'Cantons',
            'cle_unique' => ['departement', 'arrondissement', 'code'],
            'fichier' => 'https://www.insee.fr/fr/statistiques/fichier/3363419/canton2018-txt.zip',
            'nom_fichier' => 'canton2018.txt'],
        'cog_arrondissement' => ['nom' => 'Arrondissements',
            'cle_unique' => ['departement', 'code'],
            'fichier' => 'https://www.insee.fr/fr/statistiques/fichier/3363419/arrond2018-txt.zip',
            'nom_fichier' => 'arrond2018.txt'],
        'cog_departement' => ['nom' => 'Départements',
            'fichier' => 'https://www.insee.fr/fr/statistiques/fichier/3363419/depts2018-txt.zip',
            'nom_fichier' => 'depts2018.txt'],
        'cog_region' => ['nom' => 'Régions',
            'fichier' => 'region2016.txt'],
        'cog_regions_ancienne' => ['nom' => 'Anciennes définitions des régions',
            'fichier' => 'region2015.txt'],
        'cog_epci' => ['nom' => 'EPCI',
            'fichier' => 'https://www.insee.fr/fr/statistiques/fichier/2510634/Intercommunalite_Metropole_au_01-01-2021.zip',
            'nom_fichier' => 'Intercommunalite-Metropole_au_01-01-2021.xlsx',
            'xls' => ['cog_epci' => ['fichier_csv' => 'epci.txt', 'onglet' => 'EPCI', 'colonnes' => range('A', 'C'), 'ligne_depart' => 2, 'ligne_arrive' => 3000],
                'epci_relation' => ['fichier_csv' => 'epci_relation.txt', 'onglet' => 'Composition_communale', 'colonnes' => ['A', 'C'], 'ligne_depart' => 7, 'ligne_arrive' => 35000]],
            'relation' => ['code_insee' => ['fichier' => 'epci_relation', 'num_col' => 0, 'lien_col_cog_epci' => 0, 'lien_col_epci_relation' => 2]],
            'correspondance' => ['code' => 0, 'libelle' => 1, 'nature' => 2]],

        //'fichier'=>['epci.txt',['epci_composition.txt',0,1]]],
        /*'zauers' 				=> [	'nom'=>'ZAUER',
                                            'fichier'=>['ZAUER.txt',['zauer_composition.txt',0,1]]],
        'zauers_espace' 		=> [	'nom'=>'Espaces Urbains des ZAUER',
                                            'fichier'=>'epci_nature.txt'],
        'zauers_categories' 	=> [	'nom'=>'Categories des ZAUER',
                                            'fichier'=>'epci_nature.txt'],
        'zauers_communes_liens'	=> [	'nom'=>'Relations ZAUER - commune',
                                            'fichier'=>'epci_nature.txt']*/
    ];
    if ($objet)
        return $tab_cog_fichier[$objet];
    return $tab_cog_fichier;
}

function cog_config_tab_table()
{
    $tab_cog_fichier = [
        'cog_commune' => ['nom' => 'Communes'],
        'cog_canton' => ['nom' => 'Cantons'],
        'cog_arrondissement' => ['nom' => 'Arrondissements'],
        'cog_departement' => ['nom' => 'Départements'],
        'cog_region' => ['nom' => 'Régions'],
        'cog_epci' => ['nom' => 'EPCI'],
        /*'epcis_natures' 		=>	['nom'=>'Nature des EPCI'],
        'zauers' 				=>	['nom'=>'ZAUER'],
        'zauers_espace' 		=>	['nom'=>'Espace Urbain des ZAUER'],
        'zauers_categories' 	=>	['nom'=>'Categorie des ZAUER'],
        'communes_liens'		=>	['nom'=>'table de relations avec les communes']*/
    ];
    return $tab_cog_fichier;
}
